freedombone-app-matrix 18KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192193194195196197198199200201202203204205206207208209210211212213214215216217218219220221222223224225226227228229230231232233234235236237238239240241242243244245246247248249250251252253254255256257258259260261262263264265266267268269270271272273274275276277278279280281282283284285286287288289290291292293294295296297298299300301302303304305306307308309310311312313314315316317318319320321322323324325326327328329330331332333334335336337338339340341342343344345346347348349350351352353354355356357358359360361362363364365366367368369370371372373374375376377378379380381382383384385386387388389390391392393394395396397398399400401402403404405406407408409410411412413414415416417418419420421422423424425426427428429430431432433434435436437438439440441442443444445446447448449450451452453454455456457458459460461462463464465466467468469470471472473474475476477478479480481482483484485486487488489490491492493494495496497498499500501502503504505506507508509510511512513514515516517518519520521
  1. #!/bin/bash
  2. #
  3. # .---. . .
  4. # | | |
  5. # |--- .--. .-. .-. .-.| .-. .--.--. |.-. .-. .--. .-.
  6. # | | (.-' (.-' ( | ( )| | | | )( )| | (.-'
  7. # ' ' --' --' -' - -' ' ' -' -' -' ' - --'
  8. #
  9. # Freedom in the Cloud
  10. #
  11. # matrix server
  12. #
  13. # https://raw.githubusercontent.com/silvio/docker-matrix
  14. #
  15. # License
  16. # =======
  17. #
  18. # Copyright (C) 2016 Bob Mottram <bob@freedombone.net>
  19. #
  20. # This program is free software: you can redistribute it and/or modify
  21. # it under the terms of the GNU Affero General Public License as published by
  22. # the Free Software Foundation, either version 3 of the License, or
  23. # (at your option) any later version.
  24. #
  25. # This program is distributed in the hope that it will be useful,
  26. # but WITHOUT ANY WARRANTY; without even the implied warranty of
  27. # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
  28. # GNU Affero General Public License for more details.
  29. #
  30. # You should have received a copy of the GNU Affero General Public License
  31. # along with this program. If not, see <http://www.gnu.org/licenses/>.
  32. VARIANTS='full full-vim chat'
  33. IN_DEFAULT_INSTALL=0
  34. SHOW_ON_ABOUT=1
  35. MATRIX_DATA_DIR='/var/lib/matrix'
  36. MATRIX_PORT=8448
  37. MATRIX_REPO="https://github.com/matrix-org/synapse"
  38. MATRIX_COMMIT='f5a4001bb116c468cc5e8e0ae04a1c570e2cb171'
  39. REPORT_STATS="no"
  40. MATRIX_SECRET=
  41. matrix_variables=(ONION_ONLY
  42. MY_USERNAME
  43. MATRIX_SECRET
  44. DEFAULT_DOMAIN_NAME)
  45. function matrix_nginx {
  46. matrix_changed=
  47. matrix_proxy_str=' \
  48. location /matrix { \
  49. proxy_pass https://localhost:8448; \
  50. proxy_buffering on; \
  51. }'
  52. turn_proxy_str=' \
  53. location /turn { \
  54. proxy_pass https://localhost:3478; \
  55. proxy_buffering on; \
  56. }'
  57. if [[ $ONION_ONLY != 'no' ]]; then
  58. matrix_proxy_str=' \
  59. location /matrix { \
  60. proxy_pass http://localhost:8448; \
  61. proxy_buffering on; \
  62. }'
  63. turn_proxy_str=' \
  64. location /turn { \
  65. proxy_pass http://localhost:3478; \
  66. proxy_buffering on; \
  67. }'
  68. fi
  69. if [ ! -f /etc/nginx/sites-available/${DEFAULT_DOMAIN_NAME} ]; then
  70. matrix_nginx_site=/etc/nginx/sites-available/$DEFAULT_DOMAIN_NAME
  71. if [[ $ONION_ONLY == "no" ]]; then
  72. function_check nginx_http_redirect
  73. nginx_http_redirect $DEFAULT_DOMAIN_NAME
  74. echo 'server {' >> $matrix_nginx_site
  75. echo ' listen 443 ssl;' >> $matrix_nginx_site
  76. echo ' listen [::]:443 ssl;' >> $matrix_nginx_site
  77. echo " server_name $DEFAULT_DOMAIN_NAME;" >> $matrix_nginx_site
  78. echo '' >> $matrix_nginx_site
  79. echo ' # Security' >> $matrix_nginx_site
  80. function_check nginx_ssl
  81. nginx_ssl $DEFAULT_DOMAIN_NAME
  82. function_check nginx_disable_sniffing
  83. nginx_disable_sniffing $DEFAULT_DOMAIN_NAME
  84. echo ' add_header Strict-Transport-Security max-age=15768000;' >> $matrix_nginx_site
  85. echo '' >> $matrix_nginx_site
  86. echo ' # Logs' >> $matrix_nginx_site
  87. echo ' access_log /dev/null;' >> $matrix_nginx_site
  88. echo ' error_log /dev/null;' >> $matrix_nginx_site
  89. echo '' >> $matrix_nginx_site
  90. echo ' # Root' >> $matrix_nginx_site
  91. echo " root /var/www/$DEFAULT_DOMAIN_NAME/htdocs;" >> $matrix_nginx_site
  92. echo '' >> $matrix_nginx_site
  93. echo ' # Index' >> $matrix_nginx_site
  94. echo ' index index.html;' >> $matrix_nginx_site
  95. echo '' >> $matrix_nginx_site
  96. echo ' # Location' >> $matrix_nginx_site
  97. echo ' location / {' >> $matrix_nginx_site
  98. function_check nginx_limits
  99. nginx_limits $DEFAULT_DOMAIN_NAME '15m'
  100. echo ' }' >> $matrix_nginx_site
  101. echo '' >> $matrix_nginx_site
  102. echo ' # Restrict access that is unnecessary anyway' >> $matrix_nginx_site
  103. echo ' location ~ /\.(ht|git) {' >> $matrix_nginx_site
  104. echo ' deny all;' >> $matrix_nginx_site
  105. echo ' }' >> $matrix_nginx_site
  106. echo '}' >> $matrix_nginx_site
  107. else
  108. echo -n '' > $matrix_nginx_site
  109. fi
  110. echo 'server {' >> $matrix_nginx_site
  111. echo " listen 127.0.0.1:$MATRIX_PORT default_server;" >> $matrix_nginx_site
  112. echo " server_name $DEFAULT_DOMAIN_NAME;" >> $matrix_nginx_site
  113. echo '' >> $matrix_nginx_site
  114. function_check nginx_disable_sniffing
  115. nginx_disable_sniffing $DEFAULT_DOMAIN_NAME
  116. echo '' >> $matrix_nginx_site
  117. echo ' # Logs' >> $matrix_nginx_site
  118. echo ' access_log /dev/null;' >> $matrix_nginx_site
  119. echo ' error_log /dev/null;' >> $matrix_nginx_site
  120. echo '' >> $matrix_nginx_site
  121. echo ' # Root' >> $matrix_nginx_site
  122. echo " root /var/www/$DEFAULT_DOMAIN_NAME/htdocs;" >> $matrix_nginx_site
  123. echo '' >> $matrix_nginx_site
  124. echo ' # Location' >> $matrix_nginx_site
  125. echo ' location / {' >> $matrix_nginx_site
  126. function_check nginx_limits
  127. nginx_limits $DEFAULT_DOMAIN_NAME '15m'
  128. echo ' }' >> $matrix_nginx_site
  129. echo '' >> $matrix_nginx_site
  130. echo ' # Restrict access that is unnecessary anyway' >> $matrix_nginx_site
  131. echo ' location ~ /\.(ht|git) {' >> $matrix_nginx_site
  132. echo ' deny all;' >> $matrix_nginx_site
  133. echo ' }' >> $matrix_nginx_site
  134. echo '}' >> $matrix_nginx_site
  135. if [ ! -f /etc/ssl/certs/${DEFAULT_DOMAIN_NAME}.pem ]; then
  136. function_check create_site_certificate
  137. create_site_certificate $DEFAULT_DOMAIN_NAME 'yes'
  138. fi
  139. nginx_ensite $DEFAULT_DOMAIN_NAME
  140. matrix_changed=1
  141. fi
  142. if ! grep "localhost:${MATRIX_PORT}" /etc/nginx/sites-available/${DEFAULT_DOMAIN_NAME}; then
  143. sed -i "s|:443 ssl;|:443 ssl;${matrix_proxy_str}|g" /etc/nginx/sites-available/${DEFAULT_DOMAIN_NAME}
  144. sed -i "s| default_server;| default_server;${matrix_proxy_str}|g" /etc/nginx/sites-available/${DEFAULT_DOMAIN_NAME}
  145. matrix_changed=1
  146. fi
  147. if ! grep "localhost:${TURN_PORT}" /etc/nginx/sites-available/${DEFAULT_DOMAIN_NAME}; then
  148. sed -i "s|:443 ssl;|:443 ssl;${turn_proxy_str}|g" /etc/nginx/sites-available/${DEFAULT_DOMAIN_NAME}
  149. sed -i "s| default_server;| default_server;${turn_proxy_str}|g" /etc/nginx/sites-available/${DEFAULT_DOMAIN_NAME}
  150. matrix_changed=1
  151. fi
  152. if [ $matrix_changed ]; then
  153. systemctl restart nginx
  154. # wait for nginx to start otherwise user add fails later
  155. sleep 5
  156. fi
  157. }
  158. function matrix_generate_synapse_file {
  159. local filepath="${1}"
  160. cd /etc/matrix
  161. python -m synapse.app.homeserver \
  162. --config-path "${filepath}" \
  163. --generate-config \
  164. --report-stats ${REPORT_STATS} \
  165. --server-name ${DEFAULT_DOMAIN_NAME}
  166. }
  167. function matrix_configure_homeserver_yaml {
  168. local turnkey="${1}"
  169. local filepath="${2}"
  170. local ymltemp="$(mktemp)"
  171. awk -v TURNURIES="turn_uris: [\"turn:${DEFAULT_DOMAIN_NAME}/turn?transport=udp\", \"turn:${DEFAULT_DOMAIN_NAME}/turn?transport=tcp\"]" \
  172. -v TURNSHAREDSECRET="turn_shared_secret: \"${turnkey}\"" \
  173. -v PIDFILE="pid_file: ${MATRIX_DATA_DIR}/homeserver.pid" \
  174. -v DATABASE="database: \"${MATRIX_DATA_DIR}/homeserver.db\"" \
  175. -v LOGFILE="log_file: \"/dev/null\"" \
  176. -v MEDIASTORE="media_store_path: \"${MATRIX_DATA_DIR}/media_store\"" \
  177. '{
  178. sub(/turn_shared_secret: "YOUR_SHARED_SECRET"/, TURNSHAREDSECRET);
  179. sub(/turn_uris: \[\]/, TURNURIES);
  180. sub(/pid_file: \/homeserver.pid/, PIDFILE);
  181. sub(/database: "\/homeserver.db"/, DATABASE);
  182. sub(/log_file: "\/homeserver.log"/, LOGFILE);
  183. sub(/media_store_path: "\/media_store"/, MEDIASTORE);
  184. print;
  185. }' "${filepath}" > "${ymltemp}"
  186. mv ${ymltemp} "${filepath}"
  187. if [[ $ONION_ONLY != 'no' ]]; then
  188. sed -i 's|no_tls: .*|no_tls: True|g' "${filepath}"
  189. fi
  190. sed -i 's|enable_registration_captcha.*|enable_registration_captcha: False|g' "${filepath}"
  191. sed -i "s|database: \".*|database: \"${MATRIX_DATA_DIR}/homeserver.db\"|g" "${filepath}"
  192. sed -i "s|media_store_path:.*|media_store_path: \"${MATRIX_DATA_DIR}/media_store\"|g" "${filepath}"
  193. sed -i "s|pid_file:.*|pid_file: \"${MATRIX_DATA_DIR}/homeserver.pid\"|g" "${filepath}"
  194. sed -i "s|log_file:.*|log_file: \"/dev/null\"|g" "${filepath}"
  195. }
  196. function matrix_diff {
  197. DIFFPARAMS="${DIFFPARAMS:-Naur}"
  198. DEFAULT_DOMAIN_NAME="${DEFAULT_DOMAIN_NAME:-demo_server_name}"
  199. REPORT_STATS="${REPORT_STATS:-no_or_yes}"
  200. export DEFAULT_DOMAIN_NAME REPORT_STATS
  201. matrix_generate_synapse_file $INSTALL_DIR/homeserver.synapse.yaml
  202. diff -${DIFFPARAMS} $INSTALL_DIR/homeserver.synapse.yaml ${MATRIX_DATA_DIR}/homeserver.yaml
  203. rm $INSTALL_DIR/homeserver.synapse.yaml
  204. }
  205. function matrix_generate {
  206. breakup="0"
  207. [[ -z "${DEFAULT_DOMAIN_NAME}" ]] && echo "STOP! environment variable DEFAULT_DOMAIN_NAME must be set" && breakup="1"
  208. [[ -z "${REPORT_STATS}" ]] && echo "STOP! environment variable REPORT_STATS must be set to 'no' or 'yes'" && breakup="1"
  209. [[ "${breakup}" == "1" ]] && exit 1
  210. [[ "${REPORT_STATS}" != "yes" ]] && [[ "${REPORT_STATS}" != "no" ]] && \
  211. echo "STOP! REPORT_STATS needs to be 'no' or 'yes'" && breakup="1"
  212. if [ -f ${MATRIX_DATA_DIR}/homeserver.yaml ]; then
  213. rm ${MATRIX_DATA_DIR}/homeserver.yaml
  214. fi
  215. matrix_generate_synapse_file ${MATRIX_DATA_DIR}/homeserver.yaml
  216. matrix_configure_homeserver_yaml "${turnkey}" ${MATRIX_DATA_DIR}/homeserver.yaml
  217. }
  218. function remove_user_matrix {
  219. remove_username="$1"
  220. ${PROJECT_NAME}-pass -u $remove_username --rmapp matrix
  221. # TODO: There is no user removal script within synapse
  222. }
  223. function add_user_matrix {
  224. new_username="$1"
  225. new_user_password="$2"
  226. ${PROJECT_NAME}-pass -u $new_username -a matrix -p "$new_user_password"
  227. matrix_nginx
  228. retval=$(register_new_matrix_user -c ${MATRIX_DATA_DIR}/homeserver.yaml -u "${new_username}" -p "${new_user_password}" -a)
  229. echo "0"
  230. }
  231. function install_interactive_matrix {
  232. APP_INSTALLED=1
  233. }
  234. function change_password_matrix {
  235. curr_username="$1"
  236. new_user_password="$2"
  237. #${PROJECT_NAME}-pass -u "$curr_username" -a matrix -p "$new_user_password"
  238. }
  239. function reconfigure_matrix {
  240. echo -n ''
  241. }
  242. function upgrade_matrix {
  243. function_check set_repo_commit
  244. set_repo_commit /etc/matrix "matrix commit" "$MATRIX_COMMIT" $MATRIX_REPO
  245. pip install --upgrade --process-dependency-links .
  246. chown -R matrix:matrix /etc/matrix
  247. chown -R matrix:matrix $MATRIX_DATA_DIR
  248. }
  249. function backup_local_matrix {
  250. source_directory=/etc/matrix
  251. if [ -d $source_directory ]; then
  252. systemctl stop matrix
  253. function_check backup_directory_to_usb
  254. backup_directory_to_usb $source_directory matrix
  255. source_directory=$MATRIX_DATA_DIR
  256. if [ -d $source_directory ]; then
  257. backup_directory_to_usb $source_directory matrixdata
  258. fi
  259. systemctl start matrix
  260. fi
  261. }
  262. function restore_local_matrix {
  263. if [ -d /etc/matrix ]; then
  264. systemctl stop matrix
  265. temp_restore_dir=/root/tempmatrix
  266. function_check restore_directory_from_usb
  267. restore_directory_from_usb $temp_restore_dir matrix
  268. cp -r $temp_restore_dir/etc/matrix/* /etc/matrix
  269. if [ ! "$?" = "0" ]; then
  270. function_check backup_unmount_drive
  271. backup_unmount_drive
  272. exit 3783
  273. fi
  274. rm -rf $temp_restore_dir
  275. chown -R matrix:matrix /etc/matrix
  276. temp_restore_dir=/root/tempmatrixdata
  277. restore_directory_from_usb $temp_restore_dir matrixdata
  278. cp -r $temp_restore_dir$MATRIX_DATA_DIR/* $MATRIX_DATA_DIR
  279. if [ ! "$?" = "0" ]; then
  280. function_check backup_unmount_drive
  281. backup_unmount_drive
  282. exit 78352
  283. fi
  284. rm -rf $temp_restore_dir
  285. chown -R matrix:matrix $MATRIX_DATA_DIR
  286. systemctl start matrix
  287. fi
  288. }
  289. function backup_remote_matrix {
  290. source_directory=/etc/matrix
  291. if [ -d $source_directory ]; then
  292. systemctl stop matrix
  293. function_check backup_directory_to_friend
  294. backup_directory_to_friend $source_directory matrix
  295. source_directory=$MATRIX_DATA_DIR
  296. if [ -d $source_directory ]; then
  297. backup_directory_to_friend $source_directory matrixdata
  298. fi
  299. systemctl start matrix
  300. fi
  301. }
  302. function restore_remote_matrix {
  303. if [ -d /etc/matrix ]; then
  304. systemctl stop matrix
  305. temp_restore_dir=/root/tempmatrix
  306. function_check restore_directory_from_friend
  307. restore_directory_from_friend $temp_restore_dir matrix
  308. cp -r $temp_restore_dir/etc/matrix/* /etc/matrix
  309. if [ ! "$?" = "0" ]; then
  310. exit 38935
  311. fi
  312. rm -rf $temp_restore_dir
  313. chown -R matrix:matrix /etc/matrix
  314. temp_restore_dir=/root/tempmatrixdata
  315. restore_directory_from_friend $temp_restore_dir matrixdata
  316. cp -r $temp_restore_dir$MATRIX_DATA_DIR/* $MATRIX_DATA_DIR
  317. if [ ! "$?" = "0" ]; then
  318. exit 60923
  319. fi
  320. rm -rf $temp_restore_dir
  321. chown -R matrix:matrix $MATRIX_DATA_DIR
  322. systemctl start matrix
  323. fi
  324. }
  325. function remove_matrix {
  326. firewall_remove ${MATRIX_PORT}
  327. systemctl stop matrix
  328. function_check remove_turn
  329. remove_turn
  330. systemctl disable matrix
  331. if [ -f /etc/systemd/system/matrix.service ]; then
  332. rm /etc/systemd/system/matrix.service
  333. fi
  334. apt-get -y remove --purge coturn
  335. cd /etc/matrix
  336. pip uninstall .
  337. rm -rf $MATRIX_DATA_DIR
  338. rm -rf /etc/matrix
  339. deluser matrix
  340. delgroup matrix
  341. remove_onion_service matrix ${MATRIX_PORT}
  342. sed -i "/location \/matrix {/,/}/d" /etc/nginx/sites-available/${DEFAULT_DOMAIN_NAME}
  343. systemctl restart nginx
  344. remove_completion_param install_matrix
  345. sed -i '/matrix/d' $COMPLETION_FILE
  346. }
  347. function install_matrix {
  348. if [ ! -d $INSTALL_DIR ]; then
  349. mkdir -p $INSTALL_DIR
  350. fi
  351. if [[ ${ONION_ONLY} == 'no' ]]; then
  352. if [ ! -f /etc/ssl/certs/${DEFAULT_DOMAIN_NAME}.pem ]; then
  353. echo $'Obtaining certificate for the main domain'
  354. create_site_certificate ${DEFAULT_DOMAIN_NAME} 'yes'
  355. fi
  356. fi
  357. export DEBIAN_FRONTEND=noninteractive
  358. apt-get -yq install coreutils \
  359. curl file gcc git libevent-2.0-5 \
  360. libevent-dev libffi-dev libffi6 \
  361. libgnutls28-dev libjpeg62-turbo \
  362. libjpeg62-turbo-dev libldap-2.4-2 \
  363. libldap2-dev libsasl2-dev \
  364. libsqlite3-dev libssl-dev \
  365. libssl1.0.0 libtool libxml2 \
  366. libxml2-dev libxslt1-dev libxslt1.1 \
  367. make python python-dev \
  368. python-pip python-psycopg2 \
  369. python-virtualenv sqlite unzip \
  370. zlib1g zlib1g-dev
  371. pip install --upgrade pip
  372. pip install --upgrade python-ldap
  373. pip install --upgrade lxml
  374. if [ ! -d /etc/matrix ]; then
  375. function_check git_clone
  376. git_clone $MATRIX_REPO /etc/matrix
  377. if [ ! -d /etc/matrix ]; then
  378. echo $'Unable to clone matrix repo'
  379. exit 6724683
  380. fi
  381. fi
  382. cd /etc/matrix
  383. git checkout $MATRIX_COMMIT -b $MATRIX_COMMIT
  384. set_completion_param "matrix commit" "$MATRIX_COMMIT"
  385. if [ ! -d $INSTALL_DIR/matrix ]; then
  386. mkdir -p $INSTALL_DIR/matrix
  387. fi
  388. pip install --upgrade --process-dependency-links . -b $INSTALL_DIR/matrix
  389. if [ ! "$?" = "0" ]; then
  390. exit 782542
  391. fi
  392. function_check install_turn
  393. install_turn
  394. MATRIX_SECRET="${turnkey}"
  395. function_check matrix_generate
  396. matrix_generate
  397. if [[ -z ${MATRIX_DATA_DIR}/homeserver.yaml ]]; then
  398. echo $'homeserver.yaml is zero size'
  399. exit 783724
  400. fi
  401. groupadd matrix
  402. useradd -c "Matrix system account" -d $MATRIX_DATA_DIR -m -r -g matrix matrix
  403. chmod -R 700 /var/lib/matrix/homeserver.yaml
  404. chown -R matrix:matrix /etc/matrix
  405. chown -R matrix:matrix $MATRIX_DATA_DIR
  406. echo '[Unit]' > /etc/systemd/system/matrix.service
  407. echo 'Description=Synapse Matrix homeserver' >> /etc/systemd/system/matrix.service
  408. echo 'After=network.target nginx.target' >> /etc/systemd/system/matrix.service
  409. echo '' >> /etc/systemd/system/matrix.service
  410. echo '[Service]' >> /etc/systemd/system/matrix.service
  411. echo 'Type=simple' >> /etc/systemd/system/matrix.service
  412. echo 'User=matrix' >> /etc/systemd/system/matrix.service
  413. echo "WorkingDirectory=/etc/matrix" >> /etc/systemd/system/matrix.service
  414. echo "ExecStart=/usr/bin/python -m synapse.app.homeserver --config-path ${MATRIX_DATA_DIR}/homeserver.yaml" >> /etc/systemd/system/matrix.service
  415. echo 'Restart=always' >> /etc/systemd/system/matrix.service
  416. echo 'RestartSec=10' >> /etc/systemd/system/matrix.service
  417. echo '' >> /etc/systemd/system/matrix.service
  418. echo '[Install]' >> /etc/systemd/system/matrix.service
  419. echo 'WantedBy=multi-user.target' >> /etc/systemd/system/matrix.service
  420. systemctl enable matrix
  421. systemctl daemon-reload
  422. systemctl start matrix
  423. if [ -f /var/lib/matrix/homeserver.db ]; then
  424. chmod -R 700 /var/lib/matrix/homeserver.db
  425. fi
  426. update_default_domain
  427. firewall_add matrix ${MATRIX_PORT}
  428. MATRIX_ONION_HOSTNAME=$(add_onion_service matrix ${MATRIX_PORT} ${MATRIX_PORT})
  429. if [ ! ${MATRIX_PASSWORD} ]; then
  430. if [ -f ${IMAGE_PASSWORD_FILE} ]; then
  431. MATRIX_PASSWORD="$(printf `cat $IMAGE_PASSWORD_FILE`)"
  432. else
  433. MATRIX_PASSWORD="$(create_password ${MINIMUM_PASSWORD_LENGTH})"
  434. fi
  435. fi
  436. rm -rf ${MATRIX_DATA_DIR}/Maildir
  437. rm -rf ${MATRIX_DATA_DIR}/.mutt
  438. rm -f ${MATRIX_DATA_DIR}/.muttrc
  439. rm -f ${MATRIX_DATA_DIR}/.mutt-alias
  440. rm -f ${MATRIX_DATA_DIR}/.procmailrc
  441. rm -f ${MATRIX_DATA_DIR}/.emacs-mutt
  442. matrix_nginx
  443. if [[ $(add_user_matrix "${MY_USERNAME}" "${MATRIX_PASSWORD}") != "0" ]]; then
  444. echo $'Failed to add matrix admin user';
  445. exit 879352
  446. fi
  447. APP_INSTALLED=1
  448. }